#!/usr/bin/env python
# coding: utf-8

"""
16.3 딥러닝 모델의 성능
<2> 심층 신경망 구조 만들기
p.345 ~ p.347
"""

# In[1]: p.345
from sklearn import datasets
iris = datasets.load_iris()
X = iris.data
y = iris.target
from sklearn.model_selection import train_test_split
X_train, X_test, y_train, y_test = train_test_split(X, y, test_size=0.2)


# In[2]:
from keras.utils.np_utils import to_categorical
y_train = to_categorical(y_train)
y_test = to_categorical(y_test)


# In[3]:
from tensorflow.keras import models
from tensorflow.keras import layers
model = models.Sequential()

model.add(layers.Dense(2, input_shape=(4, )))
model.add(layers.Dense(3, activation='softmax'))

model.add(layers.Dense(2, input_shape=(4, )))  #input_dim=4
model.add(layers.Dense(16, activation='relu'))
model.add(layers.Dense(32, activation='relu'))
model.add(layers.Dense(3, activation='softmax'))


# In[4]: p.346
model.compile(optimizer='rmsprop', loss='categorical_crossentropy', metrics=['accuracy'])


# In[5]:
history = model.fit(X_train, y_train, validation_split=0.2, epochs=100)

