#!/usr/bin/env python
# coding: utf-8

"""
16.4 이미지와 시계열 처리모델
<2> 시계열 처리모델
(p.362 ~ p.368)
"""

# In[1]: p.362
import pandas as pd
dataset = pd.read_csv('airline-passengers.csv', engine='python')
dataset.head(3)


# In[2]:
dataset.pop('Month')
dataset.tail(3)


# In[3]: p.363
dataset.columns = ['Passengers']
dataset.head(3)


# In[4]:
dataset = dataset.dropna()
dataset.tail(3)


# In[5]:
from sklearn.preprocessing import MinMaxScaler
scaled = MinMaxScaler()
dataset = scaled.fit_transform(dataset)
print(dataset[:3])


# In[6]: p.364
train = dataset[:120]
test = dataset[120:]
print(test.shape)


# In[7]:
def create_seq(data, lookback=1):
    X_data = []
    y_data = []
    for i in range(len(data)-lookback-1):
        add = data[i:(i+lookback), 0]
        X_data.append(add)
        y_data.append(data[i + lookback, 0])
    return np.array(X_data), np.array(y_data)

import numpy as np
lookback = 1
X_train, y_train = create_seq(train, lookback)
X_test, y_test = create_seq(test, lookback)

print(X_train[:6])
print(y_train[:5])


# In[8]: p.365
X_train = np.reshape(X_train, (X_train.shape[0], 1, X_train.shape[1]))
X_test = np.reshape(X_test, (X_test.shape[0], 1, X_test.shape[1]))

X_train.shape


# In[9]:
from tensorflow.keras.models import Sequential
from tensorflow.keras.layers import Dense
from tensorflow.keras.layers import Flatten
model = Sequential()
model.add(Flatten(input_shape=(1, X_train.shape[1])))
model.add(Dense(1))
model.compile(optimizer='rmsprop', loss='mse')
history = model.fit(X_train, y_train, epochs=50, batch_size=1)


# In[10]: p.366
trainPredict = model.predict(X_train)
testPredict = model.predict(X_test)

trainPredict = scaled.inverse_transform(trainPredict)
trainY = scaled.inverse_transform([y_train])
testPredict = scaled.inverse_transform(testPredict)
testY = scaled.inverse_transform([y_test])

import matplotlib.pyplot as plt
plt.plot(scaled.inverse_transform(dataset), linestyle=':',
label='Total')
plt.plot(testPredict, label='test')
plt.legend()


# In[11]: p.367
plt.plot(scaled.inverse_transform(dataset), linestyle=':', label='Total')
plt.plot(trainPredict, label='Predict')
testPredictPlot = np.empty_like(dataset)
testPredictPlot[:] = np.nan
testPredictPlot[len(trainPredict)+(lookback*2)+1:len(dataset)-1] = testPredict
plt.plot(testPredictPlot, label='test')
plt.legend()
plt.show()